import { Scope } from "../sucrase-babylon/tokenizer/state";
import ImportProcessor from "./ImportProcessor";
import NameManager from "./NameManager";
import TokenProcessor from "./TokenProcessor";
export declare type Transform = "jsx" | "imports" | "flow" | "typescript" | "add-module-exports" | "react-display-name";
export declare type Options = {
    transforms: Array<Transform>;
};
export declare type SucraseContext = {
    tokenProcessor: TokenProcessor;
    scopes: Array<Scope>;
    nameManager: NameManager;
    importProcessor: ImportProcessor;
};
export declare function getVersion(): string;
export declare function transform(code: string, options: Options): string;
/**
 * Return a string representation of the sucrase tokens, mostly useful for
 * diagnostic purposes.
 */
export declare function getFormattedTokens(code: string, options: Options): string;
