import ImportProcessor from "../ImportProcessor";
import TokenProcessor from "../TokenProcessor";
import RootTransformer from "./RootTransformer";
import Transformer from "./Transformer";
export default class JSXTransformer extends Transformer {
    readonly rootTransformer: RootTransformer;
    readonly tokens: TokenProcessor;
    readonly importProcessor: ImportProcessor;
    constructor(rootTransformer: RootTransformer, tokens: TokenProcessor, importProcessor: ImportProcessor);
    process(): boolean;
    /**
     * Produce the props arg to createElement, starting at the first token of the
     * props, if any.
     */
    processProps(): void;
    processStringPropValue(): void;
    /**
     * Process the first part of a tag, before any props.
     */
    processTagIntro(): void;
    processChildren(): void;
    processChildTextElement(): void;
    processJSXTag(): void;
}
