"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const parser_1 = require("./parser");
const flow_1 = require("./plugins/flow");
const jsx_1 = require("./plugins/jsx");
const typescript_1 = require("./plugins/typescript");
function parse(input, plugins) {
    return getParser(plugins, input).parse();
}
exports.parse = parse;
function getParser(plugins, input) {
    if (plugins.includes("flow") && plugins.includes("typescript")) {
        throw new Error("Cannot combine flow and typescript plugins.");
    }
    if (plugins.includes("typescript")) {
        return new typescript_1.default(input, plugins);
    }
    else if (plugins.includes("flow")) {
        return new flow_1.default(input, plugins);
    }
    else if (plugins.includes("jsx")) {
        return new jsx_1.default(input, plugins);
    }
    else {
        return new parser_1.default(input, plugins);
    }
}
