import { TokenType } from "../tokenizer/types";
import UtilParser from "./util";
export default abstract class LValParser extends UtilParser {
    abstract parseIdentifier(): void;
    abstract parseMaybeAssign(noIn?: boolean | null, afterLeftParse?: Function): void;
    abstract parseObj(isPattern: boolean, isBlockScope: boolean): void;
    abstract parseDecorator(): void;
    parseSpread(): void;
    parseRest(isBlockScope: boolean): void;
    parseBindingIdentifier(): void;
    parseBindingAtom(isBlockScope: boolean): void;
    parseBindingList(close: TokenType, isBlockScope: boolean, allowEmpty?: boolean, allowModifiers?: boolean | null): void;
    parseAssignableListItem(allowModifiers: boolean | null, isBlockScope: boolean): void;
    parseAssignableListItemTypes(): void;
    parseMaybeDefault(isBlockScope: boolean, leftAlreadyParsed?: boolean): void;
}
