import { TokenType } from "../tokenizer/types";
import TypeParser from "./types";
export default class FlowParser extends TypeParser {
    flowParseTypeInitialiser(tok?: TokenType): void;
    flowParsePredicate(): void;
    flowParseTypeAndPredicateInitialiser(): void;
    flowParseDeclareClass(): void;
    flowParseDeclareFunction(): void;
    flowParseDeclare(): void;
    flowParseDeclareVariable(): void;
    flowParseDeclareModule(): void;
    flowParseDeclareExportDeclaration(): void;
    flowParseDeclareModuleExports(): void;
    flowParseDeclareTypeAlias(): void;
    flowParseDeclareOpaqueType(): void;
    flowParseDeclareInterface(): void;
    flowParseInterfaceish(isClass?: boolean): void;
    flowParseInterfaceExtends(): void;
    flowParseInterface(): void;
    flowParseRestrictedIdentifier(): void;
    flowParseTypeAlias(): void;
    flowParseOpaqueType(declare: boolean): void;
    flowParseTypeParameter(): void;
    flowParseTypeParameterDeclaration(): void;
    flowParseTypeParameterInstantiation(): void;
    flowParseObjectPropertyKey(): void;
    flowParseObjectTypeIndexer(): void;
    flowParseObjectTypeMethodish(): void;
    flowParseObjectTypeCallProperty(): void;
    flowParseObjectType(allowStatic: boolean, allowExact: boolean): void;
    flowParseObjectTypeProperty(): void;
    flowObjectTypeSemicolon(): void;
    flowParseQualifiedTypeIdentifier(initialIdAlreadyParsed: boolean): void;
    flowParseGenericType(): void;
    flowParseTypeofType(): void;
    flowParseTupleType(): void;
    flowParseFunctionTypeParam(): void;
    flowParseFunctionTypeParams(): void;
    flowIdentToTypeAnnotation(name: string): void;
    flowParsePrimaryType(): void;
    flowParsePostfixType(): void;
    flowParsePrefixType(): void;
    flowParseAnonFunctionWithoutParens(): void;
    flowParseIntersectionType(): void;
    flowParseUnionType(): void;
    flowParseType(): void;
    parseTypeAnnotation(): void;
    flowParseTypeAnnotatableIdentifier(): void;
    flowParseVariance(): void;
    parseFunctionBodyAndFinish(functionStart: number, isGenerator: boolean, allowExpressionBody?: boolean, funcContextId?: number): void;
    parseStatement(declaration: boolean, topLevel?: boolean): void;
    parseIdentifierStatement(name: string): void;
    shouldParseExportDeclaration(): boolean;
    isExportDefaultSpecifier(): boolean;
    parseExportDeclaration(): void;
    shouldParseExportStar(): boolean;
    parseExportStar(): void;
    parseClassId(isStatement: boolean, optionalId?: boolean): void;
    parseExprListItem(allowEmpty: boolean | null): void;
    parseClassProperty(): void;
    parseClassMethod(functionStart: number, isGenerator: boolean, isConstructor: boolean): void;
    parseClassSuper(): boolean;
    parsePropertyName(classContextId: number): void;
    parseObjPropValue(isGenerator: boolean, isPattern: boolean, isBlockScope: boolean, objectContextId: number): void;
    parseAssignableListItemTypes(): void;
    parseImportSpecifiers(): void;
    parseImportSpecifier(): void;
    parseFunctionParams(allowModifiers?: boolean, contextId?: number): void;
    parseVarHead(isBlockScope: boolean): void;
    parseAsyncArrowFromCallExpression(functionStart: number, startTokenIndex: number): void;
    parseMaybeAssign(noIn?: boolean | null, afterLeftParse?: Function): boolean;
    parseArrow(): boolean;
    parseSubscripts(startPos: number, noCalls?: boolean | null): void;
    parseAsyncArrowWithTypeParameters(startPos: number): boolean;
}
