import { types as tt } from "./types";
export default class State {
    init(input) {
        this.input = input;
        this.potentialArrowAt = -1;
        this.noAnonFunctionType = false;
        this.tokens = [];
        this.scopes = [];
        this.pos = 0;
        this.type = tt.eof;
        this.value = null;
        this.start = this.pos;
        this.end = this.pos;
        this.isType = false;
    }
    snapshot() {
        return {
            potentialArrowAt: this.potentialArrowAt,
            noAnonFunctionType: this.noAnonFunctionType,
            tokensLength: this.tokens.length,
            scopesLength: this.scopes.length,
            pos: this.pos,
            type: this.type,
            // tslint:disable-next-line: no-any
            value: this.value,
            start: this.start,
            end: this.end,
            isType: this.isType,
        };
    }
    restoreFromSnapshot(snapshot) {
        this.potentialArrowAt = snapshot.potentialArrowAt;
        this.noAnonFunctionType = snapshot.noAnonFunctionType;
        this.tokens.length = snapshot.tokensLength;
        this.scopes.length = snapshot.scopesLength;
        this.pos = snapshot.pos;
        this.type = snapshot.type;
        this.value = snapshot.value;
        this.start = snapshot.start;
        this.end = snapshot.end;
        this.isType = snapshot.isType;
    }
}
